using System;
using System.Data;
using System.Data.OleDb;

using Syncfusion.DLS;
using Syncfusion.DocIO.DLS;

namespace MailingLabels
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			OleDbConnection conn = null;			
			try
			{
				string dataPath = System.Environment.CurrentDirectory + "\\..\\..\\..\\Data";
				string connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + System.IO.Path.Combine(dataPath,@"db1.mdb");
				IWordDocument doc = new WordDocument();
				doc.Open(System.IO.Path.Combine(dataPath,@"MailingLabels.doc"),Syncfusion.DocIO.FormatType.Doc);
				conn = new OleDbConnection(connString);
				conn.Open();
				OleDbCommand cmd = new OleDbCommand("SELECT * FROM Customers Order By CustomerID", conn);
				IDataReader dataReader = cmd.ExecuteReader();
				doc.MailMerge.Execute(dataReader);
				doc.Save("Test.doc",Syncfusion.DocIO.FormatType.Doc);
				System.Diagnostics.Process.Start("Test.doc");
			}
			catch (Exception Ex)
			{
				Console.WriteLine(Ex.Message);
			}
			finally
			{
				if (conn != null)
					conn.Close();
			}
		}
	}
}
