using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

using Syncfusion.DLS;
using Syncfusion.DocIO.DLS;

namespace MailmergeWithGroup
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button buttonSalesInvoice;
		private System.Windows.Forms.Button buttonClose;

		string dataPath = null;
		string connString = null;
		IWordDocument doc = null;
       
		OleDbConnection conn = null;
		OleDbDataAdapter da = null;
		OleDbCommand cmd = null;
		DataSet ds = null;
		private System.Windows.Forms.ListBox listBoxCustomer;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.listBoxCustomer = new System.Windows.Forms.ListBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.buttonClose = new System.Windows.Forms.Button();
			this.buttonSalesInvoice = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Font = new System.Drawing.Font("Comic Sans MS", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(144, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 26);
			this.label1.TabIndex = 0;
			this.label1.Text = "Sales Invoice";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(152, 32);
			this.label2.TabIndex = 1;
			this.label2.Text = "Select Customer ID From the List Box";
			// 
			// listBoxCustomer
			// 
			this.listBoxCustomer.Location = new System.Drawing.Point(16, 104);
			this.listBoxCustomer.Name = "listBoxCustomer";
			this.listBoxCustomer.Size = new System.Drawing.Size(144, 134);
			this.listBoxCustomer.TabIndex = 2;
			this.listBoxCustomer.DoubleClick += new System.EventHandler(this.buttonSalesInvoice_Click);
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.Add(this.buttonClose);
			this.panel1.Controls.Add(this.buttonSalesInvoice);
			this.panel1.Location = new System.Drawing.Point(192, 112);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(152, 104);
			this.panel1.TabIndex = 3;
			// 
			// buttonClose
			// 
			this.buttonClose.Location = new System.Drawing.Point(12, 56);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.Size = new System.Drawing.Size(124, 32);
			this.buttonClose.TabIndex = 2;
			this.buttonClose.Text = "&Close";
			this.buttonClose.Click += new System.EventHandler(this.buttonClose_Click);
			// 
			// buttonSalesInvoice
			// 
			this.buttonSalesInvoice.Location = new System.Drawing.Point(12, 11);
			this.buttonSalesInvoice.Name = "buttonSalesInvoice";
			this.buttonSalesInvoice.Size = new System.Drawing.Size(124, 32);
			this.buttonSalesInvoice.TabIndex = 0;
			this.buttonSalesInvoice.Text = "Create &Sales Invloce";
			this.buttonSalesInvoice.Click += new System.EventHandler(this.buttonSalesInvoice_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(362, 264);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.listBoxCustomer);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Sales Invoice...";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Getting all customer ID's from database and added to the list box.
			try
			{
				dataPath = Application.StartupPath + "\\..\\..\\..\\Data\\";
				connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + System.IO.Path.Combine(dataPath, @"db1.mdb");
				conn = new OleDbConnection(connString);
				conn.Open();
				cmd = new OleDbCommand("select OrderID from SyncOrders Order By OrderID", conn);
				da = new OleDbDataAdapter(cmd);
				ds = new DataSet();
				da.SelectCommand = cmd;
				da.Fill(ds, "SyncOrders");
				foreach (DataRow row in ds.Tables["SyncOrders"].Rows)
					listBoxCustomer.Items.Add(row["OrderID"]);
			}
			catch (Exception Ex)
			{
				MessageBox.Show(Ex.Message,"Report", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}

		private void buttonSalesInvoice_Click(object sender, System.EventArgs e)
		{
			try
			{
				ExecuteMail_Doc((int)listBoxCustomer.SelectedItem);
				if (MessageBox.Show ("Do you want to view the MS Word document?", "Document has been created",
					MessageBoxButtons.YesNo, MessageBoxIcon.Information)
					== DialogResult.Yes) 
				{				
					System.Diagnostics.Process.Start("Test.doc");									
				}				
			}
			catch (Exception Ex)
			{
				MessageBox.Show(Ex.Message + " Please Select the Employee From ListBox", "Report", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}

		private void buttonClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void ExecuteMail_Doc(int ID)
		{
			try
			{
				doc = new WordDocument();
				doc.Open((System.IO.Path.Combine(dataPath, @"SalesInvoiceDemo.doc")), Syncfusion.DocIO.FormatType.Doc);                
				doc.MailMerge.ExecuteGroup(GetTestOrder(ID));
				doc.MailMerge.ExecuteGroup(GetTestOrderTotals(ID));
				DataView orderDetails = new DataView(GetTestOrderDetails(ID));
				orderDetails.Sort = "ExtendedPrice DESC";
				doc.MailMerge.ExecuteGroup(orderDetails);
				doc.Save("Test.doc", Syncfusion.DocIO.FormatType.Doc);
			}
			catch (Exception Ex)
			{
				MessageBox.Show(Ex.Message);
			}
		}

		private DataTable GetTestOrder(int TestOrderId)
		{
			DataTable table = ExecuteDataTable(string.Format("SELECT * FROM SyncOrders WHERE OrderId = {0}", TestOrderId));
			table.TableName = "Orders";
			return table;
		}

		private DataTable GetTestOrderDetails(int TestOrderId)
		{
			DataTable table = ExecuteDataTable(string.Format(
				"SELECT * FROM SyncOrderDetails WHERE OrderId = {0} ORDER BY ProductID", TestOrderId));
			table.TableName = "OrderDetails";
			return table;
		}

		private DataTable GetTestOrderTotals(int TestOrderId)
		{
			DataTable table = ExecuteDataTable(string.Format(
				"SELECT * FROM SyncOrderTotals WHERE OrderId = {0}", TestOrderId));
			table.TableName = "OrderTotals";
			return table;
		}

		private DataTable ExecuteDataTable(string commandText)
		{            
			// Getting Data table from the database through OleDbConnection.
			try
			{
				conn = new OleDbConnection(connString);
				conn.Open();
				cmd = new OleDbCommand(commandText, conn);
				da = new OleDbDataAdapter(cmd);
				DataTable table = new DataTable();
				da.Fill(table);
				return table;
			}
			finally
			{
				if (conn != null)
					conn.Close();
			}
		}		
	}
}
